## qt6ct 0.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16.0)

project(qt6ct LANGUAGES CXX)

include(GNUInstallDirs)

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

ADD_DEFINITIONS(-DQT_DISABLE_DEPRECATED_BEFORE=0x060000 -DUSE_WIDGETS)

find_package(Qt6 COMPONENTS BuildInternals Widgets Concurrent LinguistTools REQUIRED)

#get_target_property(QT_QTPATHS_EXECUTABLE Qt6::qtpaths IMPORTED_LOCATION)
get_target_property(QT_LRELEASE_EXECUTABLE Qt6::lrelease IMPORTED_LOCATION)

#if(QT_QTPATHS_EXECUTABLE)
#    message(STATUS "Found qtpaths executable: " ${QT_QTPATHS_EXECUTABLE})
#else()
#    message(FATAL_ERROR "Could NOT find qtpaths executable")
#endif()

if(QT_LRELEASE_EXECUTABLE)
    message(STATUS "Found lrelease executable: " ${QT_LRELEASE_EXECUTABLE})
else()
    message(FATAL_ERROR "Could NOT find lrelease executable")
endif()

get_filename_component(QT_QTPATHS_EXECUTABLE ${QT_LRELEASE_EXECUTABLE} DIRECTORY)
set(QT_QTPATHS_EXECUTABLE ${QT_QTPATHS_EXECUTABLE}/qtpaths)

if(EXISTS ${QT_QTPATHS_EXECUTABLE})
    message(STATUS "Found qtpaths executable: " ${QT_QTPATHS_EXECUTABLE})
else()
    message(FATAL_ERROR "Could NOT find qtpaths executable")
endif()

#execute_process(COMMAND ${QT_QTPATHS_EXECUTABLE} -query QT_INSTALL_PLUGINS OUTPUT_VARIABLE PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND ${QT_QTPATHS_EXECUTABLE} --plugin-dir OUTPUT_VARIABLE PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
message(STATUS "Plugin path: " ${PLUGINDIR})

message(STATUS "Generating translations ...")
execute_process(COMMAND find ${CMAKE_CURRENT_SOURCE_DIR} -name *.ts COMMAND xargs ${QT_LRELEASE_EXECUTABLE} -silent)

add_subdirectory(src/qt6ct)
add_subdirectory(src/qt6ct-qtplugin)
add_subdirectory(src/qt6ct-style)

install(DIRECTORY qss DESTINATION ${CMAKE_INSTALL_DATADIR}/qt6ct)
install(DIRECTORY colors DESTINATION ${CMAKE_INSTALL_DATADIR}/qt6ct)

if(UNIX)
    add_custom_target(distclean @echo cleaning for source distribution)

    add_custom_command(
        COMMENT "distribution clean"
        COMMAND make
        ARGS -C ${CMAKE_CURRENT_BINARY_DIR} clean
        COMMAND find
        ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "CMakeCache.txt" | xargs rm -rf
        COMMAND find
        ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "CMakeFiles" | xargs rm -rf
        COMMAND find
        ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "Makefile" | xargs rm -rf
        COMMAND find
        ARGS ${CMAKE_CURRENT_BINARY_DIR} -name \"*.cmake\" | xargs rm -rf
        COMMAND find
        ARGS ${CMAKE_CURRENT_SOURCE_DIR} -name "*.qm" | xargs rm -rf
        COMMAND find
        ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.pc" | xargs rm -rf
        COMMAND find
        ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.depends" | xargs rm -rf
        COMMAND find
        ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.cxx_parameters" | xargs rm -rf
        COMMAND find
        ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "moc_*.cpp" | xargs rm -rf
        COMMAND find
        ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "qrc_*.cxx" | xargs rm -rf
        COMMAND find
        ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*_automoc.cpp" | xargs rm -rf
        COMMAND rm
        ARGS -rf ${CMAKE_CURRENT_BINARY_DIR}/install_manifest.txt
        COMMAND find
        ARGS ${CMAKE_CURRENT_BINARY_DIR} -name *_automoc.dir | xargs rm -rf
        COMMAND rm
        ARGS -rf ${CMAKE_CURRENT_BINARY_DIR}/doc/html
        TARGET distclean
    )
endif(UNIX)

=== src/qt6ct/CMakeLists.txt ===
project(app)

set(app_SRCS
  appearancepage.cpp
  fontconfigdialog.cpp
  fontspage.cpp
  iconthemepage.cpp
  interfacepage.cpp
  main.cpp
  mainwindow.cpp
  paletteeditdialog.cpp
  qsseditordialog.cpp
  qsspage.cpp
  qt6ct.cpp
  tabpage.cpp
  troubleshootingpage.cpp
  appearancepage.ui
  fontconfigdialog.ui
  fontspage.ui
  iconthemepage.ui
  interfacepage.ui
  mainwindow.ui
  paletteeditdialog.ui
  previewform.ui
  qsseditordialog.ui
  qsspage.ui
  troubleshootingpage.ui
  translations/translations.qrc
)

add_executable(qt6ct ${app_SRCS})
target_link_libraries(qt6ct PRIVATE Qt6::Widgets Qt6::Concurrent Qt6::WidgetsPrivate)
install(TARGETS qt6ct DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES qt6ct.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

=== debian/changelog ===
qt6ct (0.5-4ubuntu1) kinetic; urgency=medium

  * Disable LTO to fix build on amd64.

 -- Rik Mills <rikmills@kde.org>  Sun, 16 Oct 2022 10:43:57 +0100

qt6ct (0.5-4build1) kinetic; urgency=medium

  * No change rebuild against qt6-base-abi (= 6.3.1)

 -- Rik Mills <rikmills@kde.org>  Fri, 19 Aug 2022 14:49:51 +0100

qt6ct (0.5-4) unstable; urgency=medium

  * Fix crossbuilds

 -- Peter Blackman <peter@pblackman.plus.com>  Sun, 07 Aug 2022 12:00:00 +0100

qt6ct (0.5-3) unstable; urgency=medium

  [ Peter Blackman ]
  * Mention the README in the man page
  * Use SPDX licence name
  * Add Salsa VCS repository

  [ Boyuan Yang ]
  * debian/control: Do not mark package as Multi-Arch: foreign.

 -- Boyuan Yang <byang@debian.org>  Sat, 06 Aug 2022 17:02:17 -0400

qt6ct (0.5-2) unstable; urgency=high

  * Add missing dependency qt6-qpa-plugins

 -- Peter Blackman <peter@pblackman.plus.com>  Fri, 22 Jul 2022 20:30:00 +0100

qt6ct (0.5-1) unstable; urgency=medium

  * Initial release. Closes: #1015863

 -- Peter Blackman <peter@pblackman.plus.com>  Fri, 22 Jul 2022 17:00:00 +0100

=== debian/control ===
Source: qt6ct
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Peter Blackman <peter@pblackman.plus.com>
Build-Depends: cmake, debhelper-compat (= 13),
 qt6-tools-dev, qt6-base-private-dev
Standards-Version: 4.6.1
Homepage: https://github.com/trialuser02/qt6ct
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/qt6ct
Vcs-Git: https://salsa.debian.org/debian/qt6ct.git

Package: qt6ct
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libqt6svg6, qt6-qpa-plugins
Description: Qt6 Configuration Tool
 Allows users to configure Qt6 settings (theme, font, icons, etc.)
 under DE/WM without Qt integration.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto


# Extra hardening flags with cmake
export DEB_CXXFLAGS_MAINT_APPEND = -fpie
export DEB_LDFLAGS_MAINT_APPEND  = -z relro -pie -fPIE


# Move plugins for cross builds
execute_after_dh_auto_install:
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	mkdir -pv debian/qt6ct/usr/lib/$(DEB_HOST_GNU_TYPE)/qt6/plugins
	mv -v debian/qt6ct/usr/lib/$(DEB_BUILD_GNU_TYPE)/qt6/plugins/* \
	       debian/qt6ct/usr/lib/$(DEB_HOST_GNU_TYPE)/qt6/plugins
	rm -rf debian/qt6ct/usr/lib/$(DEB_BUILD_GNU_TYPE)
endif


%:
	dh $@

## qt6ct 0.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 ADD_DEFINITIONS(-DQT_DISABLE_DEPRECATED_BEFORE=0x060000 -DUSE_WIDGETS)
 
-find_package(Qt6 COMPONENTS BuildInternals Widgets Concurrent LinguistTools REQUIRED)
+find_package(Qt6 COMPONENTS BuildInternals Widgets LinguistTools REQUIRED)
 
 #get_target_property(QT_QTPATHS_EXECUTABLE Qt6::qtpaths IMPORTED_LOCATION)
 get_target_property(QT_LRELEASE_EXECUTABLE Qt6::lrelease IMPORTED_LOCATION)

=== src/qt6ct-qtplugin/CMakeLists.txt ===
project(qt6ct-qtplugin)

set(app_SRCS
  main.cpp
  qt6ctplatformtheme.cpp
  ../qt6ct/qt6ct.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)

add_library(qt6ct-qtplugin MODULE ${app_SRCS})
set_target_properties(qt6ct-qtplugin PROPERTIES OUTPUT_NAME qt6ct)
target_link_libraries(qt6ct-qtplugin PRIVATE Qt6::Widgets Qt6::GuiPrivate)
install(TARGETS qt6ct-qtplugin DESTINATION ${PLUGINDIR}/platformthemes)

=== src/qt6ct-style/CMakeLists.txt ===
project(qt6ct-style)

add_definitions(-DUSE_WIDGETS)

set(app_SRCS
  plugin.cpp
  qt6ctproxystyle.cpp
  ../qt6ct/qt6ct.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)

add_library(qt6ct-style MODULE ${app_SRCS})
target_link_libraries(qt6ct-style PRIVATE Qt6::Widgets)
install(TARGETS qt6ct-style DESTINATION ${PLUGINDIR}/styles)

=== src/qt6ct/CMakeLists.txt ===
--- 
+++ 
@@ -29,6 +29,6 @@
 )
 
 add_executable(qt6ct ${app_SRCS})
-target_link_libraries(qt6ct PRIVATE Qt6::Widgets Qt6::Concurrent Qt6::WidgetsPrivate)
+target_link_libraries(qt6ct PRIVATE Qt6::Widgets Qt6::WidgetsPrivate)
 install(TARGETS qt6ct DESTINATION ${CMAKE_INSTALL_BINDIR})
 install(FILES qt6ct.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

=== debian/changelog ===
qt6ct (0.7-3) unstable; urgency=medium

  * Remove unneeded dependency on qt6-qpa-plugins. Closes: #1026958
  * Bump Standards-Version to 4.6.2, no changes needed.

 -- Peter Blackman <peter@pblackman.plus.com>  Thu, 29 Dec 2022 12:00:00 +0000

qt6ct (0.7-2) unstable; urgency=medium

  * Remove unneeded build flags

 -- Peter Blackman <peter@pblackman.plus.com>  Fri, 02 Dec 2022 11:00:00 +0000

qt6ct (0.7-1) unstable; urgency=medium

  * New Upstream release

 -- Peter Blackman <peter@pblackman.plus.com>  Wed, 16 Nov 2022 18:00:00 +0000

qt6ct (0.6-2) unstable; urgency=medium

  * Disable LTO (breaks build if enabled)

 -- Peter Blackman <peter@pblackman.plus.com>  Wed, 26 Oct 2022 20:00:00 +0100

qt6ct (0.6-1) unstable; urgency=medium

  * New Upstream release
  * Fix 'qt5' typos in the man page

 -- Peter Blackman <peter@pblackman.plus.com>  Sun, 02 Oct 2022 12:11:09 +0100

=== debian/control ===
Source: qt6ct
Section: utils
Priority: optional
Maintainer: Peter Blackman <peter@pblackman.plus.com>
Build-Depends: cmake, debhelper-compat (= 13),
 qt6-tools-dev, qt6-base-private-dev
Standards-Version: 4.6.2
Homepage: https://github.com/trialuser02/qt6ct
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/qt6ct
Vcs-Git: https://salsa.debian.org/debian/qt6ct.git

Package: qt6ct
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libqt6svg6
Description: Qt6 Configuration Tool
 Allows users to configure Qt6 settings (theme, font, icons, etc.)
 under DE/WM without Qt integration.

=== debian/rules ===
--- 
+++ 
@@ -4,12 +4,6 @@
 
 export DH_VERBOSE = 1
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
-
-
-# Extra hardening flags with cmake
-export DEB_CXXFLAGS_MAINT_APPEND = -fpie
-export DEB_LDFLAGS_MAINT_APPEND  = -z relro -pie -fPIE
-
 
 # Move plugins for cross builds
 execute_after_dh_auto_install:
@@ -20,6 +14,5 @@
 	rm -rf debian/qt6ct/usr/lib/$(DEB_BUILD_GNU_TYPE)
 endif
 
-
 %:
 	dh $@

## qt6ct 0.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,9 +12,10 @@
 ADD_CUSTOM_TARGET(uninstall
   "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
 
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_VISIBILITY_PRESET hidden)
+set(CMAKE_C_VISIBILITY_PRESET hidden)
 set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
@@ -55,7 +56,11 @@
 message(STATUS "Generating translations ...")
 execute_process(COMMAND find ${CMAKE_CURRENT_SOURCE_DIR} -name *.ts COMMAND xargs ${QT_LRELEASE_EXECUTABLE} -silent)
 
+include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/qt6ct-common)
+
+add_link_options(-Wl,--no-undefined)
 add_subdirectory(src/qt6ct)
+add_subdirectory(src/qt6ct-common)
 add_subdirectory(src/qt6ct-qtplugin)
 add_subdirectory(src/qt6ct-style)

=== src/qt6ct-common/CMakeLists.txt ===
project(qt6ct-common)

#extract version from qt6ct.h
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/qt6ct.h"
     QT6CT_VERSION_DATA REGEX "^#define[ \t]+QT6CT_VERSION_[A-Z]+[ \t]+[0-9]+.*$")

if(QT6CT_VERSION_DATA)
  foreach(item IN ITEMS MAJOR MINOR)
    string(REGEX REPLACE ".*#define[ \t]+QT6CT_VERSION_${item}[ \t]+([0-9]+).*"
       "\\1" QT6CT_VERSION_${item} ${QT6CT_VERSION_DATA})
  endforeach()
  set(QT6CT_VERSION "${QT6CT_VERSION_MAJOR}.${QT6CT_VERSION_MINOR}")
  set(QT6CT_SOVERSION "${QT6CT_VERSION_MAJOR}")
  message(STATUS "qt6ct version: ${QT6CT_VERSION}")
else()
  message(FATAL_ERROR "invalid header")
endif()

add_definitions(-DQT6CT_LIBRARY)

set(app_SRCS
  qt6ct.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)

add_library(qt6ct-common SHARED ${app_SRCS})
set_target_properties(qt6ct-common PROPERTIES VERSION ${QT6CT_VERSION})
target_link_libraries(qt6ct-common PRIVATE Qt6::Widgets)
install(TARGETS qt6ct-common DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/qt6ct/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,6 @@
   paletteeditdialog.cpp
   qsseditordialog.cpp
   qsspage.cpp
-  qt6ct.cpp
   tabpage.cpp
   troubleshootingpage.cpp
   appearancepage.ui
@@ -29,6 +28,6 @@
 )
 
 add_executable(qt6ct ${app_SRCS})
-target_link_libraries(qt6ct PRIVATE Qt6::Widgets Qt6::WidgetsPrivate)
+target_link_libraries(qt6ct PRIVATE Qt6::Widgets Qt6::WidgetsPrivate qt6ct-common)
 install(TARGETS qt6ct DESTINATION ${CMAKE_INSTALL_BINDIR})
 install(FILES qt6ct.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

=== debian/changelog ===
qt6ct (0.8-1) unstable; urgency=medium

  * New Upstream release
  * Drop desktop patch adopted upstream

 -- Peter Blackman <peter@pblackman.plus.com>  Sun, 12 Mar 2023 14:00:00 +0000

## qt6ct 0.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,12 +4,12 @@
 
 include(GNUInstallDirs)
 
-CONFIGURE_FILE(
+configure_file(
   "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
   "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
   IMMEDIATE @ONLY)
 
-ADD_CUSTOM_TARGET(uninstall
+add_custom_target(uninstall
   "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
 
 set(CMAKE_CXX_STANDARD 17)
@@ -20,41 +20,49 @@
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
 set(CMAKE_AUTOUIC ON)
+set(CMAKE_BUILD_RPATH_USE_ORIGIN ON)
 
-ADD_DEFINITIONS(-DQT_DISABLE_DEPRECATED_BEFORE=0x060000 -DUSE_WIDGETS)
+add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x060000 -DUSE_WIDGETS)
 
-find_package(Qt6 COMPONENTS BuildInternals Widgets LinguistTools REQUIRED)
+find_package(Qt6 REQUIRED COMPONENTS BuildInternals Core Widgets OPTIONAL_COMPONENTS LinguistTools)
 
-#get_target_property(QT_QTPATHS_EXECUTABLE Qt6::qtpaths IMPORTED_LOCATION)
-get_target_property(QT_LRELEASE_EXECUTABLE Qt6::lrelease IMPORTED_LOCATION)
+get_target_property(QT_QTPATHS_EXECUTABLE Qt6::qtpaths IMPORTED_LOCATION)
 
-#if(QT_QTPATHS_EXECUTABLE)
-#    message(STATUS "Found qtpaths executable: " ${QT_QTPATHS_EXECUTABLE})
-#else()
-#    message(FATAL_ERROR "Could NOT find qtpaths executable")
-#endif()
-
-if(QT_LRELEASE_EXECUTABLE)
-    message(STATUS "Found lrelease executable: " ${QT_LRELEASE_EXECUTABLE})
-else()
-    message(FATAL_ERROR "Could NOT find lrelease executable")
+if(Qt6LinguistTools_FOUND)
+    get_target_property(QT_LRELEASE_EXECUTABLE Qt6::lrelease IMPORTED_LOCATION)
+    if(NOT QT_QTPATHS_EXECUTABLE AND QT_LRELEASE_EXECUTABLE)
+        get_filename_component(QT_LRELEASE_PATH ${QT_LRELEASE_EXECUTABLE} DIRECTORY)
+        set(QT_QTPATHS_EXECUTABLE ${QT_LRELEASE_PATH}/qtpaths)
+    endif()
 endif()
 
-get_filename_component(QT_QTPATHS_EXECUTABLE ${QT_LRELEASE_EXECUTABLE} DIRECTORY)
-set(QT_QTPATHS_EXECUTABLE ${QT_QTPATHS_EXECUTABLE}/qtpaths)
-
-if(EXISTS ${QT_QTPATHS_EXECUTABLE})
-    message(STATUS "Found qtpaths executable: " ${QT_QTPATHS_EXECUTABLE})
+if(QT_QTPATHS_EXECUTABLE AND EXISTS ${QT_QTPATHS_EXECUTABLE})
+    message(STATUS "Found qtpaths executable: ${QT_QTPATHS_EXECUTABLE}")
 else()
     message(FATAL_ERROR "Could NOT find qtpaths executable")
 endif()
 
+if(Qt6LinguistTools_FOUND)
+    if(QT_LRELEASE_EXECUTABLE AND EXISTS ${QT_LRELEASE_EXECUTABLE})
+        message(STATUS "Found lrelease executable: ${QT_LRELEASE_EXECUTABLE}")
+    else()
+        message(FATAL_ERROR "Could NOT find lrelease executable")
+    endif()
+endif()
+
 #execute_process(COMMAND ${QT_QTPATHS_EXECUTABLE} -query QT_INSTALL_PLUGINS OUTPUT_VARIABLE PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
 execute_process(COMMAND ${QT_QTPATHS_EXECUTABLE} --plugin-dir OUTPUT_VARIABLE PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
-message(STATUS "Plugin path: " ${PLUGINDIR})
 
-message(STATUS "Generating translations ...")
-execute_process(COMMAND find ${CMAKE_CURRENT_SOURCE_DIR} -name *.ts COMMAND xargs ${QT_LRELEASE_EXECUTABLE} -silent)
+if(PLUGINDIR)
+   message(STATUS "Plugin path: ${PLUGINDIR}")
+else()
+   message(FATAL_ERROR "Could not get plugin path")
+endif()
+
+if(Qt6LinguistTools_FOUND)
+    message(STATUS "Generating translations ...")
+    execute_process(COMMAND find ${CMAKE_CURRENT_SOURCE_DIR}/src -name *.ts COMMAND xargs ${QT_LRELEASE_EXECUTABLE} -silent)
+endif()
 
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/qt6ct-common)

=== src/qt6ct-common/CMakeLists.txt ===
--- 
+++ 
@@ -26,5 +26,5 @@
 
 add_library(qt6ct-common SHARED ${app_SRCS})
 set_target_properties(qt6ct-common PROPERTIES VERSION ${QT6CT_VERSION})
-target_link_libraries(qt6ct-common PRIVATE Qt6::Widgets)
+target_link_libraries(qt6ct-common PRIVATE Qt6::Gui)
 install(TARGETS qt6ct-common DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/qt6ct-qtplugin/CMakeLists.txt ===
project(qt6ct-qtplugin)

set(app_SRCS
  main.cpp
  qt6ctplatformtheme.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)

add_library(qt6ct-qtplugin MODULE ${app_SRCS})
set_target_properties(qt6ct-qtplugin PROPERTIES OUTPUT_NAME qt6ct)
target_link_libraries(qt6ct-qtplugin PRIVATE Qt6::Widgets Qt6::GuiPrivate qt6ct-common)
install(TARGETS qt6ct-qtplugin DESTINATION ${PLUGINDIR}/platformthemes)

=== src/qt6ct-style/CMakeLists.txt ===
project(qt6ct-style)

add_definitions(-DUSE_WIDGETS)

set(app_SRCS
  plugin.cpp
  qt6ctproxystyle.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)

add_library(qt6ct-style MODULE ${app_SRCS})
target_link_libraries(qt6ct-style PRIVATE Qt6::Widgets qt6ct-common)
install(TARGETS qt6ct-style DESTINATION ${PLUGINDIR}/styles)

=== debian/changelog ===
qt6ct (0.9-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:25:37 +1100

qt6ct (0.9-2build1) noble; urgency=medium

  * No-change rebuild against libqt6core6t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 02:02:55 +0000

qt6ct (0.9-2) unstable; urgency=medium

  * Add licenserecon to Salsa CI

 -- Peter Blackman <peter@pblackman.plus.com>  Wed, 03 Jan 2024 10:00:00 +0100

qt6ct (0.9-1) unstable; urgency=medium

  * New Upstream release
  * Drop reproducible build patch adopted upstream

 -- Peter Blackman <peter@pblackman.plus.com>  Tue, 26 Sep 2023 22:00:00 +0100

qt6ct (0.8-2) unstable; urgency=medium

  * Fix reproducible build

 -- Peter Blackman <peter@pblackman.plus.com>  Thu, 31 Aug 2023 21:00:00 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: qt6ct
 Section: utils
 Priority: optional
-Maintainer: Peter Blackman <peter@pblackman.plus.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Peter Blackman <peter@pblackman.plus.com>
 Build-Depends: cmake, debhelper-compat (= 13),
  qt6-tools-dev, qt6-base-private-dev
 Standards-Version: 4.6.2

=== debian/watch ===
version=4
https://github.com/trialuser02/qt6ct/tags .*/v?(\d\S+)\.tar\.gz

## qt6ct 0.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,9 +22,12 @@
 set(CMAKE_AUTOUIC ON)
 set(CMAKE_BUILD_RPATH_USE_ORIGIN ON)
 
-add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x060000 -DUSE_WIDGETS)
+add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x060000)
 
-find_package(Qt6 REQUIRED COMPONENTS BuildInternals Core Widgets OPTIONAL_COMPONENTS LinguistTools)
+find_package(Qt6 REQUIRED COMPONENTS BuildInternals Core Gui OPTIONAL_COMPONENTS Widgets QuickControls2 LinguistTools)
+find_package(KF6Config)
+find_package(KF6ColorScheme)
+find_package(KF6IconThemes)
 
 get_target_property(QT_QTPATHS_EXECUTABLE Qt6::qtpaths IMPORTED_LOCATION)
 
@@ -50,8 +53,10 @@
     endif()
 endif()
 
-#execute_process(COMMAND ${QT_QTPATHS_EXECUTABLE} -query QT_INSTALL_PLUGINS OUTPUT_VARIABLE PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
-execute_process(COMMAND ${QT_QTPATHS_EXECUTABLE} --plugin-dir OUTPUT_VARIABLE PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
+if(NOT PLUGINDIR)
+    #execute_process(COMMAND ${QT_QTPATHS_EXECUTABLE} -query QT_INSTALL_PLUGINS OUTPUT_VARIABLE PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
+    execute_process(COMMAND ${QT_QTPATHS_EXECUTABLE} --plugin-dir OUTPUT_VARIABLE PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
+endif()
 
 if(PLUGINDIR)
    message(STATUS "Plugin path: ${PLUGINDIR}")
@@ -67,10 +72,12 @@
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/qt6ct-common)
 
 add_link_options(-Wl,--no-undefined)
-add_subdirectory(src/qt6ct)
 add_subdirectory(src/qt6ct-common)
 add_subdirectory(src/qt6ct-qtplugin)
-add_subdirectory(src/qt6ct-style)
+if(Qt6Widgets_FOUND)
+    add_subdirectory(src/qt6ct-style)
+    add_subdirectory(src/qt6ct)
+endif()
 
 install(DIRECTORY qss DESTINATION ${CMAKE_INSTALL_DATADIR}/qt6ct)
 install(DIRECTORY colors DESTINATION ${CMAKE_INSTALL_DATADIR}/qt6ct)

=== src/qt6ct-common/CMakeLists.txt ===
--- 
+++ 
@@ -26,5 +26,6 @@
 
 add_library(qt6ct-common SHARED ${app_SRCS})
 set_target_properties(qt6ct-common PROPERTIES VERSION ${QT6CT_VERSION})
-target_link_libraries(qt6ct-common PRIVATE Qt6::Gui)
+target_link_libraries(qt6ct-common PRIVATE Qt6::Gui $<TARGET_NAME_IF_EXISTS:KF6::ConfigCore> $<TARGET_NAME_IF_EXISTS:KF6::ColorScheme>)
+target_compile_definitions(qt6ct-common PRIVATE $<$<TARGET_EXISTS:KF6::ConfigCore>:KF_CONFIGCORE_LIB> $<$<TARGET_EXISTS:KF6::ColorScheme>:KF_COLORSCHEME_LIB>)
 install(TARGETS qt6ct-common DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/qt6ct-qtplugin/CMakeLists.txt ===
--- 
+++ 
@@ -9,5 +9,6 @@
 
 add_library(qt6ct-qtplugin MODULE ${app_SRCS})
 set_target_properties(qt6ct-qtplugin PROPERTIES OUTPUT_NAME qt6ct)
-target_link_libraries(qt6ct-qtplugin PRIVATE Qt6::Widgets Qt6::GuiPrivate qt6ct-common)
+target_link_libraries(qt6ct-qtplugin PRIVATE $<TARGET_NAME_IF_EXISTS:Qt6::WidgetsPrivate> Qt6::GuiPrivate $<TARGET_NAME_IF_EXISTS:Qt6::QuickControls2> $<TARGET_NAME_IF_EXISTS:KF6::IconThemes> qt6ct-common)
+target_compile_definitions(qt6ct-qtplugin PRIVATE $<$<TARGET_EXISTS:KF6::IconThemes>:KF_ICONTHEMES_LIB>)
 install(TARGETS qt6ct-qtplugin DESTINATION ${PLUGINDIR}/platformthemes)

=== src/qt6ct-style/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,4 @@
 project(qt6ct-style)
-
-add_definitions(-DUSE_WIDGETS)
 
 set(app_SRCS
   plugin.cpp

=== src/qt6ct/CMakeLists.txt ===
--- 
+++ 
@@ -24,10 +24,14 @@
   qsseditordialog.ui
   qsspage.ui
   troubleshootingpage.ui
-  translations/translations.qrc
 )
 
+if(Qt6LinguistTools_FOUND)
+    list(APPEND app_SRCS translations/translations.qrc)
+endif()
+
 add_executable(qt6ct ${app_SRCS})
-target_link_libraries(qt6ct PRIVATE Qt6::Widgets Qt6::WidgetsPrivate qt6ct-common)
+target_link_libraries(qt6ct PRIVATE Qt6::Widgets Qt6::GuiPrivate $<TARGET_NAME_IF_EXISTS:KF6::ConfigCore> qt6ct-common)
+target_compile_definitions(qt6ct PRIVATE USE_WIDGETS $<$<TARGET_EXISTS:KF6::ConfigCore>:KF_CONFIGCORE_LIB> $<$<TARGET_EXISTS:KF6::ColorScheme>:KF_COLORSCHEME_LIB>)
 install(TARGETS qt6ct DESTINATION ${CMAKE_INSTALL_BINDIR})
 install(FILES qt6ct.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

=== debian/changelog ===
qt6ct (0.10-2build2) questing; urgency=medium

  * No-change rebuild for Qt 6.9.2 private ABI.

 -- Rik Mills <rikmills@kde.org>  Tue, 16 Sep 2025 07:48:10 +0100

qt6ct (0.10-2build1) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.3 (LP: #2103945).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 29 Mar 2025 15:06:04 -0500

qt6ct (0.10-2) unstable; urgency=medium

  * Fix FTCBFS: Drop cross building workaround fixed by qtpaths6. 
  *  (Closes: 1095960)  (Thanks Helmut Grohne)

 -- Peter Blackman <peter@pblackman.plus.com>  Fri, 14 Feb 2025 11:25:45 +0000

qt6ct (0.10-1) unstable; urgency=medium

  * New Upstream release (Closes: #1025350)
  * Switched upstream to active fork (original archived)

 -- Peter Blackman <peter@pblackman.plus.com>  Thu, 06 Feb 2025 12:25:34 +0000

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 XSBC-Original-Maintainer: Peter Blackman <peter@pblackman.plus.com>
 Build-Depends: cmake, debhelper-compat (= 13),
  qt6-tools-dev, qt6-base-private-dev
-Standards-Version: 4.6.2
-Homepage: https://github.com/trialuser02/qt6ct
+Standards-Version: 4.7.0
+Homepage: https://github.com/ilya-fedin/qt6ct
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/qt6ct
 Vcs-Git: https://salsa.debian.org/debian/qt6ct.git

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

%:
	dh $@

## qt6ct 0.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,10 @@
-cmake_minimum_required(VERSION 3.16.0)
+cmake_minimum_required(VERSION 3.18.0)
 
 project(qt6ct LANGUAGES CXX)
+
+if(POLICY CMP0175)
+    cmake_policy(SET CMP0175 NEW)
+endif()
 
 include(GNUInstallDirs)
 
@@ -20,14 +24,18 @@
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
 set(CMAKE_AUTOUIC ON)
+set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_BUILD_RPATH_USE_ORIGIN ON)
+set(QT_NO_PRIVATE_MODULE_WARNING ON)
 
-add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x060000)
+add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x060200 -DUSE_WIDGETS -DQT_DEPRECATED_WARNINGS -DQT_MESSAGELOGCONTEXT)
+add_compile_options(-Wall -Wextra)
+include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)
 
-find_package(Qt6 REQUIRED COMPONENTS BuildInternals Core Gui OPTIONAL_COMPONENTS Widgets QuickControls2 LinguistTools)
-find_package(KF6Config)
-find_package(KF6ColorScheme)
-find_package(KF6IconThemes)
+find_package(Qt6 6.2 CONFIG REQUIRED COMPONENTS BuildInternals Core Widgets OPTIONAL_COMPONENTS LinguistTools)
+if(Qt6_VERSION VERSION_GREATER_EQUAL 6.10)
+    find_package(Qt6 6.10 CONFIG REQUIRED COMPONENTS WidgetsPrivate GuiPrivate)
+endif()
 
 get_target_property(QT_QTPATHS_EXECUTABLE Qt6::qtpaths IMPORTED_LOCATION)
 
@@ -72,12 +80,10 @@
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/qt6ct-common)
 
 add_link_options(-Wl,--no-undefined)
+add_subdirectory(src/qt6ct)
 add_subdirectory(src/qt6ct-common)
 add_subdirectory(src/qt6ct-qtplugin)
-if(Qt6Widgets_FOUND)
-    add_subdirectory(src/qt6ct-style)
-    add_subdirectory(src/qt6ct)
-endif()
+add_subdirectory(src/qt6ct-style)
 
 install(DIRECTORY qss DESTINATION ${CMAKE_INSTALL_DATADIR}/qt6ct)
 install(DIRECTORY colors DESTINATION ${CMAKE_INSTALL_DATADIR}/qt6ct)
@@ -86,6 +92,7 @@
     add_custom_target(distclean @echo cleaning for source distribution)
 
     add_custom_command(
+        POST_BUILD
         COMMENT "distribution clean"
         COMMAND make
         ARGS -C ${CMAKE_CURRENT_BINARY_DIR} clean

=== src/qt6ct-common/CMakeLists.txt ===
--- 
+++ 
@@ -22,10 +22,7 @@
   qt6ct.cpp
 )
 
-include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)
-
 add_library(qt6ct-common SHARED ${app_SRCS})
 set_target_properties(qt6ct-common PROPERTIES VERSION ${QT6CT_VERSION})
-target_link_libraries(qt6ct-common PRIVATE Qt6::Gui $<TARGET_NAME_IF_EXISTS:KF6::ConfigCore> $<TARGET_NAME_IF_EXISTS:KF6::ColorScheme>)
-target_compile_definitions(qt6ct-common PRIVATE $<$<TARGET_EXISTS:KF6::ConfigCore>:KF_CONFIGCORE_LIB> $<$<TARGET_EXISTS:KF6::ColorScheme>:KF_COLORSCHEME_LIB>)
+target_link_libraries(qt6ct-common PRIVATE Qt6::Gui)
 install(TARGETS qt6ct-common DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/qt6ct-qtplugin/CMakeLists.txt ===
project(qt6ct-qtplugin)

set(app_SRCS
  main.cpp
  qt6ctplatformtheme.cpp
)

add_library(qt6ct-qtplugin MODULE ${app_SRCS})
set_target_properties(qt6ct-qtplugin PROPERTIES OUTPUT_NAME qt6ct)
target_link_libraries(qt6ct-qtplugin PRIVATE Qt6::Widgets Qt6::GuiPrivate qt6ct-common)
install(TARGETS qt6ct-qtplugin DESTINATION ${PLUGINDIR}/platformthemes)

=== src/qt6ct-style/CMakeLists.txt ===
project(qt6ct-style)

add_definitions(-DUSE_WIDGETS)

set(app_SRCS
  plugin.cpp
  qt6ctproxystyle.cpp
)

add_library(qt6ct-style MODULE ${app_SRCS})
target_link_libraries(qt6ct-style PRIVATE Qt6::Widgets qt6ct-common)
install(TARGETS qt6ct-style DESTINATION ${PLUGINDIR}/styles)

=== src/qt6ct/CMakeLists.txt ===
--- 
+++ 
@@ -31,7 +31,6 @@
 endif()
 
 add_executable(qt6ct ${app_SRCS})
-target_link_libraries(qt6ct PRIVATE Qt6::Widgets Qt6::GuiPrivate $<TARGET_NAME_IF_EXISTS:KF6::ConfigCore> qt6ct-common)
-target_compile_definitions(qt6ct PRIVATE USE_WIDGETS $<$<TARGET_EXISTS:KF6::ConfigCore>:KF_CONFIGCORE_LIB> $<$<TARGET_EXISTS:KF6::ColorScheme>:KF_COLORSCHEME_LIB>)
+target_link_libraries(qt6ct PRIVATE Qt6::Widgets Qt6::WidgetsPrivate qt6ct-common)
 install(TARGETS qt6ct DESTINATION ${CMAKE_INSTALL_BINDIR})
 install(FILES qt6ct.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

=== debian/changelog ===
qt6ct (0.11-2) unstable; urgency=medium

  * Update man page
  * Update upstream/metadata

 -- Peter Blackman <peter@pblackman.plus.com>  Mon, 06 Oct 2025 15:06:35 +0100

qt6ct (0.11-1) unstable; urgency=medium

  * Update debian/watch to Version: 5
  * New upstream version 0.11
  * Update standards to 4.7.2 and remove Rules-Require-Root
  * Update HomePage and Upstream Author

 -- Peter Blackman <peter@pblackman.plus.com>  Sun, 05 Oct 2025 21:01:40 +0100

=== debian/control ===
Source: qt6ct
Section: utils
Priority: optional
Maintainer: Peter Blackman <peter@pblackman.plus.com>
Build-Depends: cmake, debhelper-compat (= 13),
 qt6-tools-dev, qt6-base-private-dev
Standards-Version: 4.7.2
Homepage: https://www.opencode.net/trialuser/qt6ct
Vcs-Browser: https://salsa.debian.org/debian/qt6ct
Vcs-Git: https://salsa.debian.org/debian/qt6ct.git

Package: qt6ct
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libqt6svg6
Description: Qt6 Configuration Tool
 Allows users to configure Qt6 settings (theme, font, icons, etc.)
 under DE/WM without Qt integration.

=== debian/watch ===
Version: 5

Template: Gitlab
Dist: https://www.opencode.net/trialuser/@PACKAGE@
